import { HttpServer } from "@nestjs/common";
import { NesxtConfig, ErrorHandler, ErrorRenderer, Renderer, RequestHandler } from "./interfaces";
export declare class NesxtService {
    static init(config: Partial<NesxtConfig>, handler: RequestHandler, renderer: Renderer, errorRenderer: ErrorRenderer, server: HttpServer): NesxtService;
    private initialized;
    private requestHandler?;
    private renderer?;
    private errorRenderer?;
    private errorHandler?;
    private config;
    mergeConfig(config: Partial<NesxtConfig>): void;
    setViewsDir(path: string | null): void;
    getViewsDir(): string;
    setIsDev(dev: boolean): void;
    isDev(): boolean;
    setRequestHandler(handler: RequestHandler): void;
    getRequestHandler(): RequestHandler | undefined;
    setRenderer(renderer: Renderer): void;
    getRenderer(): Renderer | undefined;
    setErrorRenderer(errorRenderer: ErrorRenderer): void;
    getErrorRenderer(): ErrorRenderer | undefined;
    setErrorHandler(handler: ErrorHandler): void;
    getErrorHandler(): ErrorHandler | undefined;
    isInternalUrl(url: string): boolean;
    isInitialized(): boolean;
    bindHttpServer(server: HttpServer): void;
    protected getViewPath(view: string): string;
}
//# sourceMappingURL=nesxt.service.d.ts.map